#import "@local/handout:0.1.0": *
#import "@preview/cetz:0.3.1"


#show: handout.with(
  title: [Warm-Up: Odd Dice],
  by: "Mark",
)

#problem()
We say a set of dice ${A, B, C}$ is _nontransitive_
if, on average, $A$ beats $B$, $B$ beats $C$, and $C$ beats $A$.
In other words, we get a counterintuitive "rock - paper - scissors" effect.

#v(2mm)

Create a set of nontransitive six-sided dice. \
#hint([All sides should be numbered with positive integers less than 10.])

#solution([
  One possible set can be numbered as follows:
  - Die $A$: $2, 2, 4, 4, 9, 9$
  - Die $B$: $1, 1, 6, 6, 8, 8$
  - Die $C$: $3, 3, 5, 5, 7, 7$

  #v(2mm)

  Another solution is below:
  - Die $A$: $3, 3, 3, 3, 3, 6$
  - Die $B$: $2, 2, 2, 5, 5, 5$
  - Die $C$: $1, 4, 4, 4, 4, 4$

])

#v(1fr)

#problem()
Now, consider the set of six-sided dice below:
- Die $A$: $4, 4, 4, 4, 4, 9$
- Die $B$: $3, 3, 3, 3, 8, 8$
- Die $C$: $2, 2, 2, 7, 7, 7$
- Die $D$: $1, 1, 6, 6, 6, 6$
- Die $E$: $0, 5, 5, 5, 5, 5$
On average, which die beats each of the others? Draw a diagram.

#solution(
  align(
    center,
    cetz.canvas({
      import cetz.draw: *

      let s = 0.8 // Scale
      let t = 13pt * s // text size
      let radius = 0.3 * s

      // Points
      let a = (-2 * s, 0.2 * s)
      let b = (0 * s, 2 * s)
      let c = (2 * s, 0.2 * s)
      let d = (1.2 * s, -2.1 * s)
      let e = (-1.2 * s, -2.1 * s)

      set-style(
        stroke: (thickness: 0.6mm * s),
        mark: (
          end: (
            symbol: ">",
            fill: black,
            offset: radius + (0.025 * s),
            width: 1.2mm * s,
            length: 1.2mm * s,
          ),
        ),
      )

      line(a, b)
      line(b, c)
      line(c, d)
      line(d, e)
      line(e, a)
      line(a, c)
      line(b, d)
      line(c, e)
      line(d, a)
      line(e, b)

      circle(a, radius: radius, fill: oblue, stroke: none)
      circle(b, radius: radius, fill: oblue, stroke: none)
      circle(c, radius: radius, fill: oblue, stroke: none)
      circle(d, radius: radius, fill: oblue, stroke: none)
      circle(e, radius: radius, fill: oblue, stroke: none)

      content(a, text(fill: white, size: t, [*A*]))
      content(b, text(fill: white, size: t, [*B*]))
      content(c, text(fill: white, size: t, [*C*]))
      content(d, text(fill: white, size: t, [*D*]))
      content(e, text(fill: white, size: t, [*E*]))
    }),
  ),
)

#v(1fr)

#problem()
Now, say we roll each die twice. What happens to the graph from the previous problem?

#solution([
  The direction of each edge is reversed!
])

#v(1fr)
