#import "@local/handout:0.1.0": *

#show: handout.with(
  title: [Somewhat Random Numbers],
  by: "Mark",
)

#problem()
Alice generates 100 random numbers uniformly from $[0,1]$. \
Bob generates 101 random numbers from $[0, 1]$, but deletes the lowest result.

#v(2mm)

Say we have both of the resulting arrays, but do not know who generated each one. \
We would like to guess which of the two was generated by Bob. \
- Say we assign the array with the smallest mean to Alice. \
  What is our probability of guessing correctly?
- How often do we guess correctly if we instead assign \
  the array with the smaller _minimum_ to Alice?


#solution([
  Looking at the mean seems like a good idea, but there's a better way: \
  Assign the array with the smaller _minimum_ to Alice.

  #v(3mm)

  To compute the probability, generate 201 numbers. \
  Assign the first 100 to Alice and the rest to Bob. \
  Look at the lowest two numbers (of these 201, *before* Bob drops his lowest).

  #v(8mm)

  We'll use the following notation: \
  `AB` means the lowest was owned by Alice, and the second-lowest, by Bob.

  #v(2mm)

  Probabilities are as follows: \
  - `AA`: $100\/201 times 99\/200 approx 0.246$
  - `AB`: $100\/201 times 101\/200 approx 0.251$
  - `BA`: $101\/201 times 100\/200 approx 0.251$ // spell:disable-line
  - `BB`: $101\/201 times 100\/200 approx 0.251$

  #v(4mm)
  Now, Bob drops his lowest number. \
  We'll cross out the number he drops and box the new lowest number (i.e, the one we observe):
  - #{
      (
        box(`A`, stroke: ored, inset: 1pt)
          + box(`A`, inset: 1pt)
          + box([: $approx 0.246$], inset: (top: 1pt, bottom: 1pt))
      )
    }
  - #{
      (
        box(`A`, stroke: ored, inset: 1pt)
          + box(strike(`B`), inset: 1pt)
          + box([: $approx 0.251$], inset: (top: 1pt, bottom: 1pt))
      )
    }
  - #{
      (
        box(strike(`B`), inset: 1pt)
          + box(`A`, stroke: ored, inset: 1pt)
          + box([: $approx 0.251$], inset: (top: 1pt, bottom: 1pt))
      )
    }
  - #{
      (
        box(strike(`B`), inset: 1pt)
          + box(`B`, stroke: ored, inset: 1pt)
          + box([: $approx 0.251$], inset: (top: 1pt, bottom: 1pt))
      )
    }
  #v(8mm)
  Alice has the smallest number in 3 of 4 cases, which have a total probability of $approx 0.749$.
])
